Skip
-------

*Working Draft - September 2017*

This is a Draft RFC Specification for Skip, a reactive programming language created by Facebook. The development of this standard started in 2016. Skip is a new and evolving language and is not complete. Significant enhancement will continue in future editions of this specification.

**What’s New/Different in this Edition**

1. Clarified that traits are *not* interfaces, but are copied into using classes. Generally tightened up wording w.r.t traits.
1. Removed the former "class/trait-named-dot" replacing it with the general dot-prefix notation to lift a top-level name declared in a named module, to the unnamed global module.
1. Beefed up the description of algenraic functions.
1. Added support for constant patterns, and allowed a leading minus on numeric literal patterns.
1. Cleaned up a bunch of odds and ends.

**License**

This specification is subject to the [Creative Commons Attribution 4.0 International ](https://creativecommons.org/licenses/by/4.0/legalcode) license. The full license is found in the [license file](./LICENSE).

# [Introduction](Introduction.md)

# [Conformance](Conformance.md)

# [Basic Concepts](Basic-Concepts.md)

# [Lexical Structure](Lexical-Structure.md)

# [Types](Types.md)

# [Expressions](Expressions.md)

# [Constants and Variables](Constants-and-Variables.md)

# [Functions](Functions.md)

# [Classes](Classes.md)

# [Generic Types, Methods, and Functions](Generic-Types-Methods-and-Functions.md)

# [Exception Handling](Exception-Handling.md)

# [Modules](Modules.md)
